/********************************** (C) COPYRIGHT  *******************************
* File Name          : CH395_network_operation.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2020/10/12
* Description        : CH395
*******************************************************************************/ 
#include "CH395_network_operation.h"
#include "CH395_interface_operation.h"
#include "MCU_communication_interface.h"
#include "CH395inc.h"
#include "CH395.h"
#include "delay.h"
#include "string.h"
#include "stdio.h"

/* CH395 */
struct _CH395_SYS  ch395inf;      /* CH395Ϣ */
extern uint8_t local_ip[];        /* CH395IPַ */
extern uint8_t gateway_ip[] ;     /* CH395 */
extern uint8_t mask_ip[];         /* CH395 */

/* CH395socket */
extern uint8_t  Socket0DesIP[4];
extern uint16_t Socket0DesPort;
extern uint16_t Socket0SourPort;
extern struct _SOCK_INF  sockinf[8];
/*******************************************************************************
* Function Name  : CH395_if_init
* Description    : CH32Ӳӿڳʼ
* Input          : None
* Return         : None
*******************************************************************************/
 void CH395_if_init(void)
{
	ch395_SPI_init();
	control_gpio_init();    /* ioصĳʼ */	
}

/*******************************************************************************
* Function Name  : CH395_init
* Description    : CH395ʼ
* Input          : None
* Return         : ʼ״̬
*******************************************************************************/
uint8_t CH395_init(void)
{
    uint8_t i;
		
	i=ch395_cmd_check_exist(0x65);
	printf("ch395_cmd_check_exist : %2x\r\n",i);
	//hile(1);
	if(i != 0x9a)return CH395_ERR_UNKNOW;
	delay_ms(10);
	i = ch395_cmd_get_ver();
  printf("CH395VER : %2x\r\n",i);

	ch395_cmd_reset();                            /* λ */
  delay_ms(100);                                /* λ֮ʱ50 */
	
  ch395_cmd_set_ipaddr(ch395inf.IPAddr);        /* CH395IPַ */
	delay_ms(10);
    ch395_cmd_set_gw_ipaddr(ch395inf.GWIPAddr);   /* صַ */
	delay_ms(10);
    ch395_cmd_set_maskaddr(ch395inf.MASKAddr);    /* 룬ĬΪ255.255.255.0*/
	delay_ms(300); 
    i = ch395_cmd_init();                         /* ʼCH395оƬ */
	
    return i;
}
/*******************************************************************************
* Function Name  : ch395_inf_init
* Description    : CH395Ϣʼ
* Input          : None
* Return         : ʼ״̬
*******************************************************************************/
void ch395_inf_init(void)
{
    memset(&ch395inf, 0, sizeof(ch395inf));        /* CH395Infȫ */
    memcpy(ch395inf.IPAddr, local_ip, 4);          /* IPַдCH395Inf */
    memcpy(ch395inf.GWIPAddr, gateway_ip, 4);      /* IPַдCH395Inf */
    memcpy(ch395inf.MASKAddr, mask_ip, 4);         /* дCH395Inf */
}

/*******************************************************************************
* Function Name  : ch395_socket_init
* Description    : CH395sockeϢʼ
* Input          : None
* Return         : None
*******************************************************************************/
void ch395_socket_init(void)
{
	memset(&sockinf[0],0,sizeof(sockinf[0]));                      /* SockInf[0]ȫ*/
  memcpy(&sockinf[0].IPAddr, Socket0DesIP, 4);                   /* ĿIPдṹ */
	sockinf[0].SourPort = Socket0SourPort;                         /* ض˿д */
	sockinf[0].DesPort = Socket0DesPort;                           /* ĿĶ˿д */
	sockinf[0].ProtoType = PROTO_TYPE_TCP;                         /* TCPģʽ */
	sockinf[0].TcpMode = TCP_CLIENT_MODE;                          /* TCPͻģʽ */ 
}

/*******************************************************************************
* Function Name  : socket_open
* Description    : CH395socke
* Input          : None
* Return         : None
*******************************************************************************/
void socket_open(void)
{
	uint8_t rc;
 
	ch395_set_socket_desip(0,sockinf[0].IPAddr);
	ch395_set_socket_prot_type(0,sockinf[0].ProtoType);
  ch395_set_socket_desport(0,sockinf[0].DesPort);
	ch395_set_socket_sourport(0,sockinf[0].SourPort);
	rc=ch395_open_socket(0);
	stop_if_error(rc); 
	rc=ch395_tcp_connect(0);
  stop_if_error(rc); 
  delay_ms(500);
}

/*********************************************************************************
* Function Name  : Socket_R_S_Buf_Modify
* Description    : Socketշ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void Socket_R_S_Buf_Modify(void )
{

   ch395_set_socket_recv_buf(0,0,4);                                     /* Socket 0 ջ4*512 = 2Kͻ2*512 = 1K*/
   ch395_set_socket_send_buf(0,4,2);  
  
   ch395_set_socket_recv_buf(1,6,4);                                     /* Socket 1 */
   ch395_set_socket_send_buf(1,10,2);  
  
   ch395_set_socket_recv_buf(2,12,4);                                    /* Socket 2 */
   ch395_set_socket_send_buf(2,16,2);  
  
   ch395_set_socket_recv_buf(3,18,4);                                    /* Socket 3 */
   ch395_set_socket_send_buf(3,22,2);  
  
   ch395_set_socket_recv_buf(4,24,4);                                    /* Socket 4 */
   ch395_set_socket_send_buf(4,28,2);  
  
   ch395_set_socket_recv_buf(5,30,4);                                    /* Socket 5 */
   ch395_set_socket_send_buf(5,34,2);
  
   ch395_set_socket_recv_buf(6,36,4);                                    /* Socket 6 */
   ch395_set_socket_send_buf(6,40,2);  
  
   ch395_set_socket_recv_buf(7,42,4);                                    /* Socket 7 */
   ch395_set_socket_send_buf(7,46,2);  

}


/**********************************************************************************
* Function Name  : KeepLive_Set
* Description    : ʱ
* Input          : sockindexsocket
                   cmd: 0-ر  1-
* Output         : None
* Return         : None
**********************************************************************************/
void KeepLive_Set(uint8_t sockindex , uint8_t cmd)
{
	ch395_keeplive_cnt(DEF_KEEP_LIVE_CNT);

	ch395_keeplive_idle(DEF_KEEP_LIVE_IDLE);

	ch395_keeplive_intvl(DEF_KEEP_LIVE_PERIOD);
	
	ch395_set_keeplive(sockindex, cmd);

}
